export { lift } from './lift';
export { update } from './immupdate';
export { range } from './array';
export { createUnion } from './union';
export { createEnum } from './enum';
export { identity, noop } from './function';
import * as isType from './is';
export declare const is: typeof isType;
export declare function immutable<T>(obj: T): Immutable<T>;
export declare type Immutable<T> = T extends ImmutablePrimitive ? T : T extends Array<infer U> ? ImmutableArray<U> : T extends Map<infer K, infer V> ? ImmutableMap<K, V> : T extends Set<infer M> ? ImmutableSet<M> : ImmutableObject<T>;
declare type ImmutablePrimitive = undefined | null | boolean | string | number | Function;
declare type ImmutableArray<T> = ReadonlyArray<Immutable<T>>;
declare type ImmutableMap<K, V> = ReadonlyMap<Immutable<K>, Immutable<V>>;
declare type ImmutableSet<T> = ReadonlySet<Immutable<T>>;
declare type ImmutableObject<T> = {
    readonly [K in keyof T]: Immutable<T[K]>;
};
