/** A Set wrapper providing extra functionalities and more chaining opportunities */
export class SetWrapper {
    constructor(_value) {
        this._value = _value;
        this._isLiftWrapper = true;
        this.pipe = pipe;
    }
    value() {
        return this._value;
    }
    clone() {
        return new SetWrapper(this._clone());
    }
    _clone() {
        return new Set(this._value);
    }
    add(item) {
        return new SetWrapper(this._clone().add(item));
    }
    delete(item) {
        const result = this._clone();
        result.delete(item);
        return new SetWrapper(result);
    }
    clear() {
        const result = this._clone();
        result.clear();
        return new SetWrapper(result);
    }
    collect(iterator) {
        const result = new Set();
        this._value.forEach(item => {
            const res = iterator(item);
            if (res !== undefined)
                result.add(res);
        });
        return new SetWrapper(result);
    }
    filter(predicate) {
        return this.collect(item => (predicate(item) ? item : undefined));
    }
    toArray() {
        return this.pipe(s => [...s]);
    }
}
let pipe;
export function setSetPipe(_pipe) {
    pipe = _pipe;
}
